//+------------------------------------------------------------------+
//|                                               fiboEMA.mq4 |
//                                                
//             

#property copyright ""
#property link      ""

extern int     timeframe      = 0;
extern double  stopLoss       = 1000; 
extern double  TakeProfit     = 500;
extern double  TrailingStop   = 100; 
extern string  Name_Expert    = "fiboEMA";
extern int     Slippage       = 3;
bool    UseSound       = false;
string  NameFileSound  = "alert.wav";
extern bool UseMoneyManagement=false;
extern double PercentPerTrade=10;
extern double  Lots           = 0.1;
//extern double  ProfitModifySL = 3;
double  s= 0;  
int init(){return(0);}

int deinit(){return(0);}

int start(){
   
   if(Bars<100)   {Print("bars less than 100");return(0);}
   if(TakeProfit<10){Print("TakeProfit less than 10");return(0);}
   
   if(timeframe==0) {timeframe=Period();}
//   double C=iClose(Symbol(),timeframe,0);

   double C8=iMA(Symbol(),timeframe,8,0,MODE_EMA,PRICE_CLOSE,0);
   double C13=iMA(Symbol(),timeframe,13,0,MODE_EMA,PRICE_CLOSE,0);
   double C21=iMA(Symbol(),timeframe,21,0,MODE_EMA,PRICE_CLOSE,0);
   double P8=iMA(Symbol(),timeframe,8,0,MODE_EMA,PRICE_CLOSE,1);
   double P13=iMA(Symbol(),timeframe,13,0,MODE_EMA,PRICE_CLOSE,1);
   double P21=iMA(Symbol(),timeframe,21,0,MODE_EMA,PRICE_CLOSE,1);
      

 
   if(AccountFreeMargin()<(1000*Lots)){
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);  }
      

if (!ExistPositions()) s=0;

if (UseMoneyManagement==true) Lots=MathCeil(AccountFreeMargin()*PercentPerTrade/10000)/10;

  if ((C8>C13) &&(C13>C21) && ((P8<P13)||(P8<P21)||(P13<P21)))
  
   { //LONG  
    if (s==2) {closeAllOrders();s=0;} 
    if (s==0) {OpenBuy();s=1;return(0);}
   }
   
   if ((C8<C13) && (C13<C21) && ((P8>P13)||(P8>P21)||(P13>P21))) 
   
   { // SHORT
   if (s==1) {closeAllOrders();s=0;}
   if (s==0) {OpenSell();s=2;return(0);}
   } 
 
 
  
   TrailingPositionsBuy(TrailingStop);  
   TrailingPositionsSell(TrailingStop);
 
return (0); }//end start

// - - - - - - FUNCTIONS - - - - - - -
 
/*void fModifyStopLoss(double tStopLoss) 
{ 
   bool result = OrderModify(OrderTicket(),OrderOpenPrice(),tStopLoss,OrderTakeProfit(),0,NULL); 
}
*/
bool ExistPositions()   {
   for(int i=0;i<OrdersTotal(); i++)  {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderComment()==Name_Expert) return(True);
         else return(false); }   }

void TrailingPositionsBuy(int trailingStop) { 
   for(int i=0;i<OrdersTotal();i++) { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderComment()==Name_Expert) { 
            if(OrderType()==OP_BUY) { 
               if(Bid-OrderOpenPrice()>trailingStop*Point) { 
                  if(OrderStopLoss()<Bid-trailingStop*Point || OrderStopLoss()==0)   {
                     ModifyStopLoss(Bid-trailingStop*Point); }}}}}} 

void TrailingPositionsSell(int trailingStop) { 
   for(int i=0;i<OrdersTotal();i++) { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderComment()==Name_Expert) { 
            if(OrderType()==OP_SELL) { 
               if(OrderOpenPrice()-Ask>trailingStop*Point) { 
                  if(OrderStopLoss()>Ask+trailingStop*Point || OrderStopLoss()==0)  {  
                     ModifyStopLoss(Ask+trailingStop*Point);}}}}}} 
 
void ModifyStopLoss(double ldStopLoss) { 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,0); 
   if (fm && UseSound) PlaySound(NameFileSound); 
} 

void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = Ask-Point*stopLoss; 
   ldTake = NormalizeDouble(GetTakeProfitBuy(),Digits); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_BUY,ldLot,NormalizeDouble(Ask,Digits),Slippage,ldStop,ldTake,lsComm,0,0,Blue); 
   if (UseSound) PlaySound(NameFileSound);   }
 
void OpenSell() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = Bid+Point*stopLoss; 
   ldTake = NormalizeDouble(GetTakeProfitSell(),Digits); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_SELL,ldLot,NormalizeDouble(Bid,Digits),Slippage,ldStop,ldTake,lsComm,0,0,Red); 
   if (UseSound) PlaySound(NameFileSound);   }

// close all open and pending orders

void closeAllOrders()  {
   for(int c=0;c<OrdersTotal();c++) {
     OrderSelect(c,SELECT_BY_POS,MODE_TRADES); 
         if (OrderType() == OP_BUY)  {
            OrderClose(OrderTicket(), OrderLots(),Bid,3, Red);  }
         if (OrderType() == OP_SELL)  {
            OrderClose(OrderTicket(), OrderLots(), Ask,3, Red);  }   
         if (OrderType() > 1)  { OrderDelete(OrderTicket()); }
   }
} 

// end closeAllOrders() 

string GetCommentForOrder() { return(Name_Expert); } 
double GetSizeLot() { return(Lots); } 
double GetTakeProfitBuy() { return(Ask+TakeProfit*Point); } 
double GetTakeProfitSell() { return(Bid-TakeProfit*Point); } 